require 'rexml/text'

module JenkinsWorkflow
  class Build

    attr_accessor :url

    def initialize(url: nil)
      @url = url
    end

    #
    def create(depot_path: nil, credential: nil, job_name: nil, branch: nil,
               mailto: nil, test_ubuntu12: nil, test_ubuntu14: nil,
               test_centos6: nil)
      groovy = IO.read(File.absolute_path('../build.groovy', __FILE__))

      workflow_script = eval("s = <<-END\n#{groovy}\nEND")

      xml =<<-END.gsub(/^[ ]{8}/, '')
        <flow-definition plugin="workflow-job@1.10">
          <actions/>
          <description/>
          <keepDependencies>false</keepDependencies>
          <properties>
          </properties>
          <logRotator class="hudson.tasks.LogRotator">
            <daysToKeep>60</daysToKeep>
            <numToKeep>10</numToKeep>
            <artifactDaysToKeep>-1</artifactDaysToKeep>
            <artifactNumToKeep>-1</artifactNumToKeep>
          </logRotator>
          <definition class="org.jenkinsci.plugins.workflow.cps.CpsFlowDefinition" plugin="workflow-cps@1.10">
            <script>#{REXML::Text.new(workflow_script, true, nil, false)}</script>
            <sandbox>false</sandbox>
          </definition>
          <triggers>
            <hudson.triggers.TimerTrigger>
              <spec>H 1 * * *</spec>
            </hudson.triggers.TimerTrigger>
          </triggers>
        </flow-definition>
      END

      client.job.create_or_update(job_name, xml)
    end

    private

    def client
      JenkinsApi::Client.new(server_url: url,
                             log_level: Logger::WARN)
    end
  end
end